/*
	CGI Source for TextRead.cpp

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: January 29, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: Visual C++ 4.2
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab
*/

#include "TextRead.h"
#include <stdlib.h>
#include <string.h>

TextRead::TextRead()
{
}

TextRead::~TextRead()
{
}

void TextRead::GetEnv()
{
	char	*buf;

	/*
	** Get environment variable form HTTP
	*/
	buf = (char *)getenv("QUERY_STRING");

	for (int i=0; i<2; i++)
	{
		(iParam+i)->f_val  = (char *)makeword(buf, '&');
		(iParam+i)->f_name = (char *)makeword((iParam+i)->f_val, '=');

#ifdef _DEBUG_
	printf("%s%c", (iParam+i)->f_name, LF);
	printf("%s%c", (iParam+i)->f_val, LF);
#endif
	}

	/*
	** Get values from iParam
	*/
	iBoardNum = atoi((iParam+0)->f_val);
	iTextNum  = atoi((iParam+1)->f_val);

	/*
	** Get Config from 'GuestBook.conf'
	*/
	ProcessConfig();

	/*
	** Get Total Text
	*/
	sprintf(fname, "%s%s", GetBbsDir(), "guestbook.dat");
	fpt = fopen(fname, "r");

	if (fpt == NULL)
	{
		fclose(fpt);
		printf("Can't open %s.", fname);
		exit(1);
	}
	fread(hdr, HEADER_SIZE, 1, fpt);
	iTotal = atoi(hdr->szTotal);
	fclose(fpt);
}

stat TextRead::GetOpenFile()
{
	/*
	** Update count in the 'guestbook.dat'
	** fopen()
	**	'r' or 'rb':	open for reading
	**	'w' or 'wb':	truncate to zero length or create for writing
	**	'r+'or 'r+b':	open for update (reading and writing)
	**	'w+'or 'w+b':	truncate or create for update
	*/
	sprintf(fname, "%s%s", GetBbsDir(), "guestbook.dat");

	fpt = fopen(fname, "r+");
	if (fpt == NULL)
	{
		printf("Can't open %s!!!%c", fname, LF);
		return	ERR;
	}

	return	OK;
}

void TextRead::UpdateCount()
{
	long	lSkip;
	fpos_t	pos;
	int	iCount;

	lSkip = HEADER_SIZE + RECORD_SIZE*(GetTextNum() - 1);

	/*
	** jump to the localtion and get current file pointer
	*/
	fseek(fpt, lSkip, SEEK_SET);
	fgetpos(fpt, &pos);	

	fread(rcd, RECORD_SIZE, 1, fpt);
	iCount = atoi(rcd->szCount);	/* convert string into integer	*/

#ifdef _DEBUG_
	printf("iCount = %d%c<br>", iCount, LF);
#endif

	iCount++;			/* increase one			*/
	sprintf(rcd->szCount, "%4d", iCount);
	fsetpos(fpt, &pos);		/* set file pointer		*/
	fwrite(rcd, RECORD_SIZE, 1, fpt);

#ifdef _DEBUG_
	printf("ptr->szCount = %s pos = %d%c<br>", rcd->szCount, pos, LF);
#endif

	fclose(fpt);
}

void TextRead::GetFileName()
{
	/*
	** Get file name from iBoardNum and iTextNum
	*/

	if (!strcmp(rcd->szHtmlName, ""))
		sprintf(rcd->szHtmlName, "%s", "nofile");

	sprintf(fname, "%s%s", GetBbsDir(), rcd->szHtmlName);

#ifdef _DEBUG_
	printf("fname = %s%c", fname, LF);
#endif
}

void TextRead::SetRecord()
{
	long	lSkip;

	lSkip = HEADER_SIZE + RECORD_SIZE*(GetTextNum() - 1);

	/*
	** jump to the localtion and get current file pointer
	*/
	fseek(fpt, lSkip, SEEK_SET);

	fread(rcd, RECORD_SIZE, 1, fpt);

#ifdef _DEBUG_
	printf("iCount = %d%c<br>", iCount, LF);
#endif
	fclose(fpt);
}

void TextRead::ShowHtmlFile()
{
	char	ch;
	char	szDate[50];
	int	iLeft, iRight;

	sprintf(szDate, "%s %s", rcd->szDate, rcd->szTime);

	/*
	** Read 'guestbook#.html'
	*/
	fpt = fopen(fname, "r");

	if (fpt == NULL)
	{
		printf("<html>%c", LF);
		printf("<body>%c", LF);
		printf("%s is not found!!!%c", fname, LF);
		printf("</body>%c", LF);
		printf("</html>%c", LF);
		exit(1);
	}

	printf("<html>%c", LF);
	printf("<head><title>Խ  2.11</title></head>%c", LF);
	printf("<body bgcolor=white>%c", LF);

	printf("<center>%c", LF);
	printf("<table border=0><caption><b><font size=-1>%s</font></b></caption>%c", rcd->szTitle, LF);

	/*
	** Jump a few lines
	*/
	printf("<tr><th>  </th></tr>%c", LF);
	printf("<tr><th>  </th></tr>%c", LF);

	printf("<tr><th><font size=-1> ۹ȣ </font></th><td>%4s</td><th><font size=-1> Ƚ </font></th><td>%4s</td></tr>%c",
		rcd->szNumber, rcd->szCount, LF);
	printf("<tr><th><font size=-1>۾</font></th><td><font size=-1>%s</font></td><th><font size=-1>۾¥</font></th><td><font size=-1>%s</font></td></tr>%c",
		rcd->szName, szDate, LF);
	printf("<tr><th><font size=-1>E-mail</font></th><td><a href=mailto:%s><font size=-1>%s</font></a></td>",
		rcd->szEmail, rcd->szEmail);
	printf("<th><font size=-1>URL</font></th><td><a href=http://%s><font size=-1>%s</font></a></td></tr>%c", rcd->szDomain, rcd->szDomain, LF);
	printf("<tr><th><font size=-1>Homepage</font></th><td><a href=%s><font size=-1>%s</font></a></td>%c", rcd->szHomePage, rcd->szHomePage, LF);
	printf("<th><font size=-1> ټ </font></th><td><font size=-1>%s</font></td></th></tr>%c", rcd->szLine, LF);
	printf("</table>%c", LF);

	printf("<img width=420 src=%sImage/blue_line.gif>%c", GetBaseDir(), LF);
	printf("<br><br>%c", LF);

	printf("<table border=0>%c", LF);
	//printf("<tr><td><font face=\"arial\"><pre>%c", LF);
	printf("<tr><td><font size=-1>%c", LF);

	/*
	** Show contents in the file
	*/
	while ((ch = getc(fpt)) != EOF)
		putchar(ch);

	fclose(fpt);

	printf("</font></table>%c", LF);
	printf("<br><br>%c", LF);

	/*
	** Next and Before
	*/
	iLeft  = GetTextNum() + 1;
	iRight = GetTextNum() - 1;

	if (iLeft <= GetTotalText())
		printf("<a href=%scgi-bin/TextRead.exe?BoardNum=%d&TextNum=%d>", GetBaseDir(), GetBoardNum(), iLeft);
	printf("<img src=%sImage/prev.gif border=0 align=middle>%c", GetBaseDir(), LF);

	if (iLeft <= GetTotalText())
		printf("</a>%c", LF);

	/*
	** Go to Center
	*/
	printf("<a href=%scgi-bin/TextBoard.exe?BoardNum=%d&TextNum=0>", GetBaseDir(), GetBoardNum());
	printf("<img src=%sImage/up.gif border=0 align=center></a>%c", GetBaseDir(), LF);

	if (iRight != 0)
		printf("<a href=%scgi-bin/TextRead.exe?BoardNum=%d&TextNum=%d>", GetBaseDir(), GetBoardNum(), iRight);

	printf("<img src=%sImage/next.gif border=0 align=middle>%c", GetBaseDir(), LF);
	if (iRight != 0)
		printf("</a>%c", LF);
	
	printf("<br><br>%c", LF);

	/*
	** Erase form method
	*/
	printf("<table>%c", LF);
	printf("<font size=-1>%c", LF);
	printf("<td><form OnSubmit=\"return confirm('Ȯ ðڽϱ?')\" method=post action=%scgi-bin/TextErase.exe?BoardNum=%d&TextNum=%d>%c", GetBaseDir(), GetBoardNum(), GetTextNum(), LF);
	printf("<font size=-1>Password:</font> <input type=password size=10 maxlength=10 name=password>%c", LF);
	printf("<input type=submit value=\"\"></form></td>%c", LF);

	printf("<td><form OnSubmit=\"return confirm('Ȯ Ͻðڽϱ?')\" method=post action=%scgi-bin/TextCorrect.exe?BoardNum=%d&TextNum=%d>%c", GetBaseDir(), GetBoardNum(), GetTextNum(), LF);
	printf("<input type=submit value=\"ϱ\">%c", LF);
	printf("<input type=password size=10 maxlength=10 name=password> <font size=-1>:Password</font></form>%c", LF);
	printf("</font></td>%c", LF);
	printf("</table>%c", LF);

	printf("<img src=%sImage/line.gif width=500 border=0><br>%c", GetBaseDir(), LF);
	printf("<font color=454545 size=-1>Copyright <font size=4>&copy</font> 1996 - 1997,%c", LF);
	printf("Ver 2.11 Software Engineering Lab. All rights reserved.<br>%c", LF);
	printf("Dept. of Electronic Engineering. Chonbuk National Univ.<br>%c", LF);
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/>Programmed by Kang Jul Ki</a><br>%c", LF);
	printf("<a href=mailto:%s>%s</a></br>%c", GetEmail(), GetEmail(), LF);
	printf("</font>%c", LF);

	printf("</center>%c", LF);
	printf("</body>%c", LF);
	printf("</html>%c", LF);
}
	
/*
** Program Entry
*/

void main()
{
	TextRead*	MyTextRead;
	stat		result;

	MyTextRead = new TextRead;

	/*
	** Mime type
	*/
	printf("Content-type: text/html%c%c", LF, LF);

	MyTextRead->GetEnv();

	result = MyTextRead->GetOpenFile();

	if (result == ERR)
	{
		delete	MyTextRead;
		exit(0);
	}

	MyTextRead->UpdateCount();
	MyTextRead->SetRecord();
	MyTextRead->GetFileName();
	MyTextRead->ShowHtmlFile();

	delete	MyTextRead;
}
